int num_dots = 15;

int[] hxs;
int[] hys;
color[] hcols;

int which_drag;
float radius = 20.0;

void setup()
{
  size( 500, 500 );
  hxs = new int[ num_dots ];
  hys = new int[ num_dots ];
  hcols = new color[ num_dots ];

  for ( int idx = 0; idx < num_dots; ++idx ) {
    hxs[idx] = int(random( width ));
    hys[idx] = int(random( height ));
    hcols[idx] = color( random(255), random(255), random(255) );
  }
  which_drag = -1;
}

void draw()
{
  background( 220 );
  for ( int idx = 0; idx < num_dots; ++idx ) {
    if ( which_drag == idx ) {
      stroke( 255, 0, 0 );
    } else {
      stroke( 0, 0, 0 );
    }
    fill( hcols[idx] );
    ellipse( hxs[idx], hys[idx], 2.0*radius, 2.0*radius );
  }
}

void mousePressed()
{
  for ( int idx = 0; idx < num_dots; ++idx ) {
    int dx = mouseX - hxs[idx];
    int dy = mouseY - hys[idx];
    if ( sqrt(sq(dx) + sq(dy)) <= radius ) {
      which_drag = idx;
    }
  }
}

void mouseDragged()
{
  if ( which_drag != -1 ) {
    hxs[which_drag] = mouseX;
    hys[which_drag] = mouseY;
  }
}

void mouseReleased()
{
  which_drag = -1;
}

