// A more elaborate demonstration of ControlP5 in which there
// are a few buttons, and we decide what action to take depending
// on which button was pressed.

import controlP5.*;

ControlP5 ui;
Button circle_button;
Button rect_button;
Button clear_button;

void setup()
{
  size( 400, 300 );
  ui = new ControlP5( this );
  
  circle_button = ui.addButton( "Circle" )
    .setPosition( 10, 10 )
    .setSize( 80, 80 );
  rect_button = ui.addButton( "Rectangle" )
    .setPosition( 10, 110 )
    .setSize( 80, 80 );
  clear_button = ui.addButton( "Clear" )
    .setPosition( 10, 210 )
    .setSize( 80, 80 );
    
  background( 220 );
}

void draw()
{}

void controlEvent( ControlEvent ev )
{
  fill( random(255), random(255), random(255) );

  if( ev.isFrom( circle_button ) ) {
    // Create a random circle.
    float r = lerp( 10, 40, random(1) );
    float x = lerp( 100+r, width-r, random(1) );
    float y = lerp( r, height-r, random(1) );
    ellipse( x, y, 2*r, 2*r );
  } else if( ev.isFrom( rect_button ) ) {
    // Create a random rectangle.
    float w = lerp( 10, 60, random(1) );
    float h = lerp( 10, 60, random(1) );
    float x = lerp( 100+w, width-w, random(1) );
    float y = lerp( h, height-h, random(1) );
    rect( x, y, w, h );
  } else if( ev.isFrom( clear_button ) ) {
    // Clear the canvas.
    background( 220 );
  }
}
